import java.util.Hashtable;  // this is part of Java Runtime
import com.hp.itsm.api.interfaces.*;  // these reside in web-api.jar so be sure to include it in the classpath
import com.hp.itsm.api.ApiSDSession;  // this one reside in web-api.jar as well
import info.skolnik.radovan.hpovsd45.sso.ApiSDSessionHelper;  // this one if from sso_web_api.jar so include that on in classpath too


public class WebApiSsoDemo {

  public static void main(String args[]) {
    if (args.length != 3) {
      System.err.println("Usage: WebApiSsoDemo <server> <secret_key> <NT_Domain_Name> <NT_Domain_Login>");
      System.exit(1);
    }
    try {
      // fill up Hashtable with your variables and their respective values
      Hashtable vars = new Hashtable();
      // we put values here as to satisfy sample AFQ filter
      vars.put("$NT_DOMAIN$", args[2]);
      vars.put("$NT_NAME$", args[3]);

      // retrieve session - it should be a session for s Person who's Source ID matches $NT_DOMAIN$\$NT_NAME$ (or 2nd_cli_argument\3rd_cli_argument)
      // so be sure to update some Person's Source ID this way before running this otherwise you won't get any match.
      // Or you can change the AFQ to suit your mappings
      ApiSDSession session = ApiSDSessionHelper.openSession(args[0], args[1], vars, true);

      // we will dump some values to show we got the appropriate record

      IAccount account = session.getCurrentAccount();
      System.out.println("Account: Display name='" + account.getDisplayName() + "' Login name='" + account.getLoginName() + "'");
      IPerson persons[] = account.getPerson_Account();
      // there should be at most one such record
      if ((persons != null) && (persons.length > 0)) {
        System.out.println("Person: Name='" + persons[0].getName() + "' Searchcode='" + persons[0].getSearchcode() + "'");
      }
      // just exit now

      System.exit(0);

    } catch (Exception ex) {
      System.err.println("Oopppss - something unexpected happened: " + ex);
      System.exit(2);
    }
  }

}